local playername = UnitName("player")
local lootitemstring = string.gsub(LOOT_ITEM, "%%s", "(.+)")
local lootitemmultiplestring = string.gsub(LOOT_ITEM_MULTIPLE, "%%s", "(.+)")
local lootitemselfstring = string.gsub(LOOT_ITEM_SELF, "%%s", "(.+)")
local lootitemselfmultiplestring = string.gsub(LOOT_ITEM_SELF_MULTIPLE, "%%s", "(.+)")

BadgeWatch = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")

local mod = BadgeWatch

local BadgeList = {}

function mod:OnEnable()
	self:RegisterEvent("CHAT_MSG_LOOT")
end

function mod:CHAT_MSG_LOOT(msg)
	local name, item
	
	name, item = select(3, string.find(msg, lootitemstring))
	if not name or not item then
		name, item = select(3, string.find(msg, lootitemmultiplestring))
	end
	
	if not name or not item then
		item = select(3, string.find(msg, lootitemselfstring))
		if item then
			name = playername
		else
			item = select(3, string.find(msg, lootitemselfmultiplestring))
			if item then
				name = playername
			end
		end
	end


	if type(item) ~= "string" or type(name) ~= "string" then return end
	local itemid = select(2, GetItemInfo(item)):match("item:(%d+)")
	if tonumber(itemid) ~= 29434 then return end

	self:ScheduleEvent("BadgeWatchEnd", self.EndTracking, 2*60, self)
	self:ScheduleEvent("BadgeWatchReset", self.ResetTracking, 10*60, self)

	BadgeList[name] = true
end

function mod:EndTracking()
	for i = 1, GetNumRaidMembers() do
		local name,_,group = GetRaidRosterInfo(i)
		if name and not BadgeList[name] and (group < 6) then
			SendChatMessage("You forgot to loot your badges!", "WHISPER", nil, name)
		end
	end
end

function mod:ResetTracking()
	BadgeList = {}
end
